pootpoot = LibStub("AceAddon-3.0"):NewAddon("pootpoot", "AceEvent-3.0", "AceConsole-3.0", "AceTimer-3.0")
local pootpoot = pootpoot

pootpoot.title = "pootpoot"
pootpoot.version = GetAddOnMetadata(pootpoot.title, "Version")
pootpoot.xbuild = GetAddOnMetadata(pootpoot.title, "X-Build")

local CombatLog_Object_IsA = CombatLog_Object_IsA

local COMBATLOG_OBJECT_NONE = COMBATLOG_OBJECT_NONE
local COMBATLOG_FILTER_MINE = COMBATLOG_FILTER_MINE
--local COMBATLOG_FILTER_POOT = bit.bor (
--					COMBATLOG_OBJECT_AFFILIATION_MINE,
--					COMBATLOG_OBJECT_TARGET)
--local COMBATLOG_FILTER_POOTPLAYER = bit.bor (
--					COMBATLOG_OBJECT_AFFILIATION_MINE,
--					COMBATLOG_OBJECT_TYPE_PLAYER)

local IsInInstance = IsInInstance

pootpoot.zoneenable = true
pootpoot.inpvpzone = false

local optionsFrame
local profilesFrame

function pootpoot:DisableWarriorSpells()
	self.db.profile.chargetgl = false
	self.db.profile.executetgl = false
	self.db.profile.mortalstriketgl = false
	self.db.profile.rampagetgl = false
	self.db.profile.shieldslamtgl = false
	self.db.profile.taunttgl = false
	self.db.profile.devastatetgl = false
	self.db.profile.bloodthirsttgl = false
	self.db.profile.bladestormtgl = false
	self.db.profile.shockwavetgl = false
	self.db.profile.heroicleaptgl = false
	self.db.profile.colossussmashtgl = false
end

function pootpoot:DisableMageSpells()
	self.db.profile.fireballtgl = false		--fire
	self.db.profile.fireballcasttgl = false
	self.db.profile.fireblasttgl = false
	self.db.profile.pyroblasttgl = false
	self.db.profile.pyroblastcasttgl = false
	self.db.profile.scorchtgl = false
	self.db.profile.scorchcasttgl = false
	self.db.profile.dragonsbreathtgl = false
	self.db.profile.frostbolttgl = false	--frost
	self.db.profile.frostboltcasttgl = false
	self.db.profile.coneofcoldtgl = false
	self.db.profile.polymorphtgl = false	--arcane
	self.db.profile.blinktgl = false
	self.db.profile.arcanebarragetgl = false
	self.db.profile.livingbombtgl = false
	self.db.profile.deepfreezetgl = false
end

function pootpoot:DisableShamanSpells()
	self.db.profile.stormstriketgl = false
	self.db.profile.lightningbolttgl = false
	self.db.profile.lightningboltcasttgl = false
	self.db.profile.earthshocktgl = false
	self.db.profile.flameshocktgl = false
	self.db.profile.purgetgl = false
	self.db.profile.frostshocktgl = false
	self.db.profile.chainlightningtgl = false
	self.db.profile.bloodlusttgl = false
	self.db.profile.thunderstormtgl = false
	self.db.profile.feralspirittgl = false
	self.db.profile.riptidetgl = false
end

function pootpoot:DisableHunterSpells()
	self.db.profile.arcaneshottgl = false
	self.db.profile.chimerashottgl = false
	self.db.profile.explosiveshottgl = false
end

function pootpoot:DisableWarlockSpells()
	self.db.profile.shadowbolttgl = false
	self.db.profile.shadowboltcasttgl = false
	self.db.profile.deathcoiltgl = false
	self.db.profile.lifetaptgl = false
	self.db.profile.curseofshadowtgl = false
	self.db.profile.corruptiontgl = false
	self.db.profile.immolatetgl = false
	self.db.profile.immolatecasttgl = false
	self.db.profile.shadowburntgl = false
	self.db.profile.howlofterrortgl = false
	self.db.profile.curseofagonytgl = false
	self.db.profile.hellfiretgl = false
	self.db.profile.incineratetgl = false
	self.db.profile.incineratecasttgl = false
	self.db.profile.curseofweaknesstgl = false
	self.db.profile.curseofrecklessnesstgl = false
	self.db.profile.curseoftonguestgl = false
	self.db.profile.curseofdoomtgl = false
	self.db.profile.seedofcorruptiontgl = false
	self.db.profile.banishtgl = false
	self.db.profile.feartgl = false
	self.db.profile.siphonlifetgl = false
	self.db.profile.dreadsteedtgl = false
	self.db.profile.unstableafflictiontgl = false
	self.db.profile.haunttgl = false
	self.db.profile.metamorphosistgl = false
	self.db.profile.chaosbolttgl = false
	self.db.profile.chaosboltcasttgl = false
	self.db.profile.shadowflametgl = false
	self.db.profile.summonfelhuntertgl = false
	self.db.profile.summonimptgl = false
	self.db.profile.summonsuccubustgl = false
	self.db.profile.summonvoidwalkertgl = false
	self.db.profile.summonfelguardtgl = false
	self.db.profile.soulstonetgl = false

end

function pootpoot:DisableRogueSpells()
	self.db.profile.sinisterstriketgl = false
	self.db.profile.hemorrhagetgl = false
	self.db.profile.evisceratetgl = false
	self.db.profile.rupturetgl = false
	self.db.profile.sliceanddicetgl = false
	self.db.profile.deadlythrowtgl = false
	self.db.profile.kidneyshottgl = false
	self.db.profile.backstabtgl = false
	self.db.profile.gougetgl = false
	self.db.profile.shivtgl = false
	self.db.profile.blindtgl = false
	self.db.profile.feignttgl = false
	self.db.profile.shadowsteptgl = false
	self.db.profile.cloakofshadowstgl = false
	self.db.profile.vanishtgl = false
	self.db.profile.garrotetgl = false
	self.db.profile.cheapshottgl = false
	self.db.profile.ambushtgl = false
	self.db.profile.mutilatetgl = false
	self.db.profile.envenomtgl = false
	self.db.profile.bladeflurrytgl = false
	self.db.profile.hungerforbloodtgl = false
	self.db.profile.killingspreetgl = false
	self.db.profile.shadowdancetgl = false
end

function pootpoot:DisablePaladinSpells()
	self.db.profile.consecrationtgl = false
	self.db.profile.beaconoflighttgl = false
	self.db.profile.hammeroftherighteoustgl = false
	self.db.profile.divinestormtgl = false
	self.db.profile.judgementofrighteousnesstgl = false
	self.db.profile.judgementofcommandtgl = false
	self.db.profile.crusaderstriketgl = false
	self.db.profile.summonchargertgl = false
end

function pootpoot:DisableDruidSpells()
	self.db.profile.starfalltgl = false
	self.db.profile.berserktgl = false
	self.db.profile.wildgrowthtgl = false
end

function pootpoot:DisablePriestSpells()
	self.db.profile.penancetgl = false
	self.db.profile.guardianspirittgl = false
	self.db.profile.dispersiontgl = false
end

function pootpoot:DisableDeathKnightSpells()
	self.db.profile.acherusdeathchargertgl = false
	self.db.profile.deathgriptgl = false
end

function pootpoot:DisableEnchants()
	self.db.profile.crusaderproctgl = false
end

function pootpoot:DisableGeneralSpells()
	self.db.profile.dingtgl = false
	self.db.profile.interrupttgl = false
	self.db.profile.cannibalizetgl = false
end

function pootpoot:ChatCommand(input)
	LibStub("AceConfigCmd-3.0").HandleCommand(pootpoot, "ppc", "pootpoot", input)
end

function pootpoot:OpenPootConfig()
	LibStub("AceConfigDialog-3.0"):SetDefaultSize("pootpoot", 500, 350)
	LibStub("AceConfigDialog-3.0"):Open("pootpoot", configFrame)
end

function pootpoot:OpenPootProfileConfig()
	InterfaceOptionsFrame_OpenToCategory(self.profilesFrame)
end

function pootpoot:PootOnYou(input)
	local t=UnitName("target")
	if( t ) then
		if( t ~= self.player ) then
			SendChatMessage("poots on %t.", "EMOTE", nil, nil)
		else
			local genderTable = { "its", "his", "her" }
			SendChatMessage('poots ' .. genderTable[UnitSex(t)] .. ' pants.', "EMOTE", nil, nil)
		end
	else
		SendChatMessage("poots.", "EMOTE", nil, nil)
	end
end

function pootpoot:FoamOnMe(input)
	SendChatMessage("foams at the mouth.", "EMOTE", nil, nil)
end

function pootpoot:Bong(input)
	local t=UnitName("target")
	if( t ) then
		if( t ~= self.player ) then
			SendChatMessage("passes the bong to %t.", "EMOTE", nil, nil)
		else
			SendChatMessage("hits the bong.", "EMOTE", nil, nil)
		end
	else
		SendChatMessage("hits the bong.", "EMOTE", nil, nil)
	end
end

function pootpoot:OnInitialize()

	self:SetupDefaults()
	
	self:SetupOptions()

	self:RegisterChatCommand("pootpoot", "ChatCommand")
	self:RegisterChatCommand("ppc", "ChatCommand")
	self:RegisterChatCommand("poot", "PootOnYou")
	self:RegisterChatCommand("foam", "FoamOnMe")
	self:RegisterChatCommand("bong", "Bong")

	self.player = UnitName("player")
	local playerClass, englishClass = UnitClass("player")
	self.class = englishClass
	pootpoot.zoneenable = true
end

function pootpoot:OnEnable()
	self:RegisterEvent("PLAYER_LEVEL_UP")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED","ParseCombat")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	--self:RegisterComm(self.title)
	self.MiniIcon.Reposition()
	self.MiniIcon.Update()
end

function pootpoot:OnDisable()
end

function pootpoot:DispPootMsg( dmessage, dmsgtype )
	local tbl = { strsplit(";", dmessage) }
	SendChatMessage( tbl[math.random(#tbl)], dmsgtype, nil, nil )
end

function pootpoot:GetStringVar(info)
	return self.db.profile[info[#info]]
end

function pootpoot:SetStringVar(info, newValue)
	self.db.profile[info[#info]] = newValue
end

function pootpoot:GetToggleVar(info)
	return self.db.profile[info[#info]]
end

function pootpoot:SetToggleVar(info, newValue)
	self.db.profile[info[#info]] = newValue
end

function pootpoot:SetZoneVar(info, newValue)
	self.db.profile[info[#info]] = newValue
	self:ZoneCheck()
end

function pootpoot:GetChance(info)
	return self.db.profile[info[#info]]
end

function pootpoot:SetChance(info, newValue)
	self.db.profile[info[#info]] = newValue
end

function pootpoot:ZoneCheck()
	if InCombatLockdown() then
		self:ScheduleTimer("ZoneCheck", 1, self)
		return
	end
	local inInstance, instanceType
	inInstance, instanceType = IsInInstance()

	if inInstance then
		pootpoot.zoneenable = true
		if instanceType == "pvp" then
			DEFAULT_CHAT_FRAME:AddMessage("PVP")
			pootpoot.inpvpzone = true
		else
			pootpoot.inpvpzone = false
		end
	else
		pootpoot.zoneenable = false
		pootpoot.inpvpzone = false
	end
end

function pootpoot:PLAYER_ENTERING_WORLD(event)
	self:ZoneCheck()
end

function pootpoot:PLAYER_LEVEL_UP(args)
	if (self.db.profile.dingtgl) then
		pootpoot:DispPootMsg( self.db.profile.ding, "SAY" )
	end
end

function pootpoot:ParseCombat(arg1, timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2, ...)
	if not self.db.profile.enabled then
		return
	end
	
	self:ParseGeneralCombat(arg1, timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
	if self.class == "WARRIOR" then
		self:ParseWarriorCombat(arg1, timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
	elseif self.class == "PALADIN" then
		self:ParsePaladinCombat(arg1, timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
	elseif self.class == "WARLOCK" then
		self:ParseWarlockCombat(arg1, timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
	elseif self.class == "SHAMAN" then
		self:ParseShamanCombat(arg1, timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
	elseif self.class == "ROGUE" then
		self:ParseRogueCombat(arg1, timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
	elseif self.class == "MAGE" then
		self:ParseMageCombat(arg1, timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
	elseif self.class == "PRIEST" then
		self:ParsePriestCombat(arg1, timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
	elseif self.class == "HUNTER" then
		self:ParseHunterCombat(arg1, timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
	elseif self.class == "DEATHKNIGHT" then
		self:ParseDeathknightCombat(arg1, timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
	elseif self.class == "DRUID" then
		self:ParseDruidCombat(arg1, timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
	end
end

--minimap functions
function pootpoot:SetShowMinimap(info, newValue)
	self.db.profile.showMinimap = newValue
	pootpoot.MiniIcon.Reposition()
	pootpoot.MiniIcon.Update()
end

function pootpoot:ShowingMinimap()
	return self.db.profile.showMinimap
end

--DEFAULT_CHAT_FRAME:AddMessage("Message")